"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const error_1 = require("./error");
const urlModule = __importStar(require("url"));
const url_1 = require("url");
const process_1 = require("process");
const constants_1 = __importDefault(require("./constants"));
const { CHAR_LOWERCASE_A, CHAR_LOWERCASE_Z } = constants_1.default;
const isWindows = (process_1.platform === 'win32' || process.env.__TEST_WIN32_API);
const forwardSlashRegEx = /\//g;
function getPathFromURLWin32(url) {
    const hostname = url.hostname;
    var pathname = url.pathname;
    for (var n = 0; n < pathname.length; n++) {
        if (pathname[n] === '%') {
            var third = pathname.codePointAt(n + 2) | 0x20;
            if ((pathname[n + 1] === '2' && third === 102) || // 2f 2F /
                (pathname[n + 1] === '5' && third === 99)) { // 5c 5C \
                throw new error_1.ERR_INVALID_FILE_URL_PATH('must not include encoded \\ or / characters');
            }
        }
    }
    pathname = pathname.replace(forwardSlashRegEx, '\\');
    pathname = decodeURIComponent(pathname);
    if (hostname !== '') {
        // If hostname is set, then we have a UNC path
        // Pass the hostname through domainToUnicode just in case
        // it is an IDN using punycode encoding. We do not need to worry
        // about percent encoding because the URL parser will have
        // already taken care of that for us. Note that this only
        // causes IDNs with an appropriate `xn--` prefix to be decoded.
        return `\\\\${url_1.domainToUnicode(hostname)}${pathname}`;
    }
    else {
        // Otherwise, it's a local path that requires a drive letter
        var letter = pathname.codePointAt(1) | 0x20;
        var sep = pathname[2];
        if (letter < CHAR_LOWERCASE_A || letter > CHAR_LOWERCASE_Z || // a..z A..Z
            (sep !== ':')) {
            throw new error_1.ERR_INVALID_FILE_URL_PATH('must be absolute');
        }
        return pathname.slice(1);
    }
}
function getPathFromURLPosix(url) {
    if (url.hostname !== '') {
        throw new error_1.ERR_INVALID_FILE_URL_HOST(process_1.platform);
    }
    const pathname = url.pathname;
    for (var n = 0; n < pathname.length; n++) {
        if (pathname[n] === '%') {
            var third = pathname.codePointAt(n + 2) | 0x20;
            if (pathname[n + 1] === '2' && third === 102) {
                throw new error_1.ERR_INVALID_FILE_URL_PATH('must not include encoded / characters');
            }
        }
    }
    return decodeURIComponent(pathname);
}
// exported for testing
function poly_fileURLToPath(pathArg) {
    const path = typeof pathArg === 'string' ? new url_1.URL(pathArg) : pathArg;
    if (path == null || !(path instanceof url_1.URL))
        throw new error_1.ERR_INVALID_ARG_TYPE('path', ['string', 'URL'], path);
    if (path.protocol !== 'file:')
        throw new error_1.ERR_INVALID_URL_SCHEME('file');
    return isWindows ? getPathFromURLWin32(path) : getPathFromURLPosix(path);
}
exports.poly_fileURLToPath = poly_fileURLToPath;
exports.fileURLToPath = ('fileURLToPath' in urlModule)
    ? urlModule.fileURLToPath
    : poly_fileURLToPath;
